<template>
  <Row class="manager-stock-data-upload">
    <div class="error-alert" :style="{right: errorAlertRight}">
      <Alert type="error" show-icon>
        File extension error
        <span slot="desc">Only allow text file.</span>
      </Alert>
    </div>
    <Row :gutter="16">
      <i-col :span="12" class="col-box">
        <Upload
          multiple type="drag" action=""
          accept="text/plain"
          :show-upload-list="false"
          :before-upload="getUploadDataAction">
          <div class="upload-box">
            <span> Click to browse the files or drag and drop file here! </span>
          </div>
        </Upload>
      </i-col>
      <i-col :span="12" class="col-box">
        <div class="file-list">
          <Row :gutter="8">
            <i-col v-for="(item, index) in uploadData" :key="index"
                  :span="8" class="file-item-box">
              <Row class="file-item">
                <div class="file-delete-btn" @click="removeFileAction(index)">
                  <Icon type="md-trash" size="20"></Icon>
                </div>
                <div class="file-name overflow-dot">{{ item.file.name }}</div>
                <div class="file-info">
                  <div>size: {{ Math.ceil(item.file.size/1024) }}kb</div>
                </div>
              </Row>
            </i-col>
          </Row>
        </div>
        <template v-if="uploadData.length > 0">
          <div class="btn-box">
            <div class="literal-div-btn clear-btn" @click="clearUploadFileAction">Clear</div>
            <div class="literal-div-btn upload-btn" @click="uploadFilesAction">Upload</div>
          </div>
        </template>
      </i-col>
    </Row>
  </Row>
</template>

<script>
import { validators as api } from '../../../configs/request-validator/stock-data';

const actions = {
  getUploadDataAction(file) {
    this.uploadData.push({ file });
  },
  removeFileAction(index) {
    this.uploadData.splice(index, 1);
  },
  async uploadFilesAction() {
    const hasFileToUpload = this.uploadData.length > 0;
    if (hasFileToUpload) {
      const requestData = { stockData: this.uploadData };

      try {
        await this.$api(api.UploadRequest, requestData);
        this.uploadData = [];
      } catch (error) {
        this.$apiErrorHandler(error);
      }
    }
  },
  clearUploadFileAction() {
    this.uploadData = [];
  }
};

export default {
  name: 'update',
  data() {
    return {
      uploadData: [],
      errorAlertRight: '-300px',
    };
  },
  computed: {
    uploadDataAmount() {
      return this.uploadData.length;
    }
  },
  watch: {},
  methods: {
    ...actions,
  },
  mounted() {
    this.$displayBodyBlock(false);
  },
}
</script>

<style lang="scss" scoped>
  .manager-stock-data-upload {
    padding: 40px;
    overflow-x: hidden;
    .error-alert {
      position: absolute;
      right: -300px;
      transition: right 0.3s;
      z-index: 999;
    }
    .col-box {
      height: calc(100vh - 150px);
      .upload-box {
        position: relative;
        height: 100%;
        font-size: 24px;
        font-weight: bold;
        line-height: calc(100vh - 150px);
        vertical-align: middle;
      }
      .file-list {
        height: 90%;
        padding: 10px;
        overflow-y: auto;
        .file-item-box {
          padding: 0 10px;
          .file-item {
            height: 100px;
            padding: 10px 15px;
            border-radius: 4px;
            margin: 0 0 5px 0;
            &:before {
              position: absolute;
              content: "";
              width: 100%;
              height: 100%;
              border-radius: 4px;
              background: url("/images/background.jpg") 0 0 no-repeat;
              background-size: cover;
              z-index: -1;
              top: 0;
              left: 0;
            }
            .file-delete-btn {
              position: absolute;
              right: -5px;
              top: -5px;
              height: 30px;
              width: 30px;
              border-radius: 16px;
              text-align: center;
              line-height: 28px;
              vertical-align: middle;
              cursor: pointer;
            }
            .file-name {
              height: 40px;
              padding: 0 10px;
              font-size: 20px;
              font-weight: bold;
            }
            .file-info {
              padding: 0 10px;
            }
          }
        }
      }
      .btn-box {
        height: 10%;
        padding: 30px 10px;
      }
    }
  }
</style>
